--xyzspain
--- animacion lift,work and markers
--- trailer and grainplane


Greatplains = {};

function Greatplains.prerequisitesPresent(specializations) 
 
return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;
function Greatplains:load(xmlFile)
print("lua loaded Greatplains" );
self.setJointRotLimit = SpecializationUtil.callSpecializationsFunction("setJointRotLimit");

-- animacion
	self.anim = SpecializationUtil.callSpecializationsFunction("anim");
	self.Go = {}; 
	self.Done = {};
	self.charId = {};
	self.clipIndex = {};
	self.CheckDone = {};
	self.animParts = {}
	self.Activated = {};
	
	local count = getXMLInt(xmlFile, "vehicle.animParts#count");
	local part = self.animParts;
    for i=1, count do
		part[i] = {};
		local partname = string.format("vehicle.animParts.part".."%d", i);
	    local nameR = getXMLString(xmlFile, partname.."#name");
		self.charId[nameR] = Utils.indexToObject(self.components, getXMLString(xmlFile, partname.."#rootNode"));
		self.clipIndex[nameR] = getXMLString(xmlFile, partname.."#animationClip");
		self.CheckDone[nameR] = false;
		self.Activated[nameR] = false;
	end; 	
	
	self.AllActivated = SpecializationUtil.callSpecializationsFunction("AllActivated");	
  --desplazamiento de conjuntos
	self.setHydraulicDirection = SpecializationUtil.callSpecializationsFunction("setHydraulicDirection");
	
	local hydraulicsCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.hydraulics#count"), 0);	
	self.hydraulics = {};	
	for i=1, hydraulicsCount do
		local hydraulicName = string.format("vehicle.hydraulics.hydraulic%d", i);		
		self.hydraulics[i] = {};		
		self.hydraulics[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#index"));
		self.hydraulics[i].punch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punch"));
		self.hydraulics[i].translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punchFixpoint"));
		self.hydraulics[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#fixpoint"));	
		local ax, ay, az;		
		if self.hydraulics[i].punch ~= nil then
			ax, ay, az = getWorldTranslation(self.hydraulics[i].punch);
		else
			ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
		end;
		local bx, by, bz = getWorldTranslation(self.hydraulics[i].translationPunch);		
		self.hydraulics[i].punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		self.hydraulics[i].doScale = Utils.getNoNil(getXMLBool(xmlFile, hydraulicName .. "#doScale"), false);
	end;
	--rotaciones y translaciones
	local rotationNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation1#index"));
    if rotationNode1 ~= nil then
        self.rotation1 = {};
        self.rotation1.node = rotationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#minRot"));
        self.rotation1.minRot = {};
        self.rotation1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#maxRot"));
        self.rotation1.maxRot = {};
        self.rotation1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#rotTime"), 2)*1000;
     
    end;
local rotationNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation2#index"));
    if rotationNode2 ~= nil then
        self.rotation2 = {};
        self.rotation2.node = rotationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#minRot"));
        self.rotation2.minRot = {};
        self.rotation2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#maxRot"));
        self.rotation2.maxRot = {};
        self.rotation2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#rotTime"), 2)*1000;
     
    end;
	local rotationNode3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation3#index"));
    if rotationNode3 ~= nil then
        self.rotation3 = {};
        self.rotation3.node = rotationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#minRot"));
        self.rotation3.minRot = {};
        self.rotation3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#maxRot"));
        self.rotation3.maxRot = {};
        self.rotation3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#rotTime"), 2)*1000;
     
    end;
	local rotationNode4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation4#index"));
    if rotationNode4 ~= nil then
        self.rotation4 = {};
        self.rotation4.node = rotationNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation4#minRot"));
        self.rotation4.minRot = {};
        self.rotation4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation4#maxRot"));
        self.rotation4.maxRot = {};
        self.rotation4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
		
	
      self.rotation4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation4#rotTime"), 2)*1000;
     
    end;
	local rotationNode5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotation5#index"));
    if rotationNode5 ~= nil then
        self.rotation5 = {};
        self.rotation5.node = rotationNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#minRot"));
        self.rotation5.minRot = {};
        self.rotation5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#maxRot"));
        self.rotation5.maxRot = {};
        self.rotation5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
		
	
      self.rotation5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation5#rotTime"), 2)*1000;
     
    end;
	
	--rotacion wheelmarkers
		self.drumNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index1"));
	self.drumNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.drum#index2"));
	  self.drumRotationScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.drum#rotationScale"), 1);
	  self.lastSpeed=0;
	  ---------
	---flashlights
	self.FlashLightLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.indexl#index"));
    self.FlashLightRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.indexr#index"));	  

    self.flashLightLeftActive = false;
    self.flashLightRightActive = false;
    self.flash = false;
    self.flashRight = false;
    self.flashLeft = false;
    self.delayOnLeft = 0;
    self.delayOffLeft = 0;
    self.delayOnRight = 0;
    self.delayOffRight = 0;
    self.delayOn = 0;
    self.delayOff = 0;
	 turnSoundFile = Utils.getFilename("turn.wav", self.baseDirectory);
    self.turnSoundId = createSample("turnSound");
    loadSample(self.turnSoundId, turnSoundFile, false);
	
	---------------
		---sonidos-
local workSound = getXMLString(xmlFile, "vehicle.workSound#file");
    if workSound ~= nil and workSound ~= "" then
        workSound = Utils.getFilename(workSound, self.baseDirectory); 
        self.workSound = createSample("workSound");
        self.workSoundEnabled = false;
        loadSample(self.workSound, workSound, false);
        self.workSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#pitchOffset"), 1);
        self.workSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#volume"), 1);
    end;
	
	---particulas
	self.groundParticleSystems1 = {};
    local psName = "vehicle.groundParticleSystem1";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems1, psName, self.components, false, nil, self.baseDirectory)
	self.groundParticleSystems2 = {};
    local psName = "vehicle.groundParticleSystem2";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems2, psName, self.components, false, nil, self.baseDirectory)
	self.groundParticleSystems3 = {};
    local psName = "vehicle.groundParticleSystem3";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems3, psName, self.components, false, nil, self.baseDirectory)
	--------
	--grano y trailer
	self.findTrailerRaycastCallback = Combine.findTrailerRaycastCallback;
	self.trailerPosition = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.trailerPosition#index"));
    self.trailer = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.trailer#index"));
	setVisibility(self.trailer,false);
	self.grainUnloading = 100;
	self.setFillLevel = SpecializationUtil.callSpecializationsFunction("setFillLevel");
  
	  self.aiaktiv = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.aiLeftMarker#index"));
    self.speedViolationMaxTime = 1800;
    self.speedViolationTimer = self.speedViolationMaxTime;
	
    self.seeds = {};
    for k, fruitType in pairs(FruitUtil.fruitTypes) do
        if fruitType.allowsSeeding then
            self.seeds[fruitType.index] = fruitType.index;
        end;
    end;
	 self.lastFillDelta = 0;
    self.capacity = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.capacity"), 0.0);
    self.fillLevel = 0;
    self.fillTypes = {};

    local fruitTypes = getXMLString(xmlFile, "vehicle.fillTypes#fruitTypes");
    if fruitTypes ~= nil then
        local types = Utils.splitString(" ", fruitTypes);
        for k,v in pairs(types) do
            local desc = FruitUtil.fruitTypes[v];
            if desc ~= nil then
                self.fillTypes[desc.index] = true;
            end;
        end;
    end;
	-------------------
		
	  self.grainPlanes = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.grainPlane.node(%d)", i);
        local t = getXMLString(xmlFile, key.."#type");
        local index = getXMLString(xmlFile, key.."#index");
        if t==nil or index==nil then
            break;
        end;

        local node = Utils.indexToObject(self.components, index);
        if node ~= nil then
            setVisibility(node, false);
            if self.defaultGrainPlane == nil then
                self.defaultGrainPlane = node;
            end;
            self.grainPlanes[t] = node;
        end;
        i = i +1;
    end;
    if self.defaultGrainPlane==nil then
        self.grainPlanes = nil;
    end;

    self.grainPlaneMinY, self.grainPlaneMaxY = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.grainPlane#minMaxY"));
    if self.grainPlaneMinY == nil or self.grainPlaneMaxY == nil then
        local grainAnimCurve = AnimCurve:new(linearInterpolator4);
        local keyI = 0;
        while true do
            local key = string.format("vehicle.grainPlane.key(%d)", keyI);
            local t = getXMLFloat(xmlFile, key.."#time");
            local yValue = getXMLFloat(xmlFile, key.."#y");
            local scaleX,scaleY,scaleZ = Utils.getVectorFromString(getXMLString(xmlFile, key.."#scale"));
            if y == nil or scaleX == nil or scaleY == nil or scaleZ == nil then
                break;
            end;
            grainAnimCurve:addKeyframe({x=scaleX, y=scaleY, z=scaleZ, w=yValue, time = t});
            keyI = keyI +1;
        end;
        if keyI > 0 then
            self.grainAnimCurve = grainAnimCurve;
        end;
        self.grainPlaneMinY = 0;
        self.grainPlaneMaxY = 0;
    end;
	 self.currentSeed =FruitUtil.FRUITTYPE_UNKNOWN;
	 --------------
	 --revoluciones tractor
		self.lowerRmp = SpecializationUtil.callSpecializationsFunction("lowerRmp");
		----------------
	 --ai--
	 self.aiTerrainDetailChannel1 = g_currentMission.cultivatorChannel;
    self.aiTerrainDetailChannel2 = g_currentMission.ploughChannel;
    self.stop = false; 
	----	
	self.firstDo = {};
	self.arm = {};
	
	self.Go.Work = false;
	self.Done.Work = true;
	self.go = false;
	self.rotation4Max= false;
	self.rotation5Max= false;
	
	
	
end;

function Greatplains:delete()
Utils.deleteParticleSystem(self.groundParticleSystems1);
 Utils.deleteParticleSystem(self.groundParticleSystems2);
  Utils.deleteParticleSystem(self.groundParticleSystems3);
  
end;
function Greatplains:mouseEvent(posX, posY, isDown, isUp, button)
end;
function Greatplains:keyEvent(unicode, sym, modifier, isDown)
	if self.attacherVehicle and self.attacherVehicle.isAITractorActivated then
	self.autorizacion=false;
	else
	self.autorizacion=true;
	if isDown and sym == Input.KEY_n and  self.Go.Work  and not self.rotation4Max then		
		self.Go.Lift = not self.Go.Lift; 
		self.Done.Lift = true;
	end;
	end;
	if isDown and sym == Input.KEY_m  then		
	self.rotation2Max = not self.rotation2Max;
	end;
	if isDown and sym == Input.KEY_v then	
	self.Go.Work = not self.Go.Work; 
		self.Done.Work = true;
		self.offsound =false;
		-- self.activarAreas = not self.activarAreas;	
	
	end;	
	if isDown and sym == Input.KEY_x   then
	self.go = not self.go; 
	self.rotation4Max = not self.rotation4Max;
		self.rotation5Max = not self.rotation5Max;
		end;
		
if isDown and sym == Input.KEY_KP_7  and self.go then	
		self.Go.LeftMarker = true; 
		self.Done.LeftMarker = true;
		self.Go.RightMarker = false; 
		self.Done.RightMarker = true;
	end;
	if isDown and sym == Input.KEY_KP_9 and self.go then	
		self.Go.LeftMarker = false; 
		self.Done.LeftMarker = true;
		self.Go.RightMarker = true; 
		self.Done.RightMarker = true;
	end;
	if isDown and sym == Input.KEY_KP_8  and self.go then	
		self.Go.LeftMarker = false; 
		self.Done.LeftMarker = true;
		self.Go.RightMarker = false; 
		self.Done.RightMarker = true;
	end;
	---- grano y trailer
  
		
   local trailer = g_currentMission.objectToTrailer[self.trailerFound];
	 if self.trailerFound ~= 0 and self.fillTypes[trailer.currentFillType] == true then
	 setVisibility(self.trailer,false);
	 --- cuando encuentra el trailer asigna la semilla correspondiente
	 self.currentSeed = trailer.currentFillType;
    			if self.currentFillType == trailer.currentFillType or self.fillLevel == 0 then
				if isDown and sym == Input.KEY_o  then ---- sin una tecla cuando se acerca empieza a llenar solo
				
			self.rotation3Max = true;
			local x, y, z = getRotation(self.rotation3.node);
			if z > Utils.degToRad(160) then
			local deltaLevel = self.grainUnloading;
					
	    		deltaLevel = math.min(deltaLevel, trailer.capacity - trailer.fillLevel);
				

	    			self.fillLevel = self.fillLevel+deltaLevel;
				
	    			if self.fillLevel >= self.capacity then
	         			self.fillLevel = self.capacity;
						self.activeUnloading = false;
	    			end;
	    			if trailer.fillLevel <= 0.0 then
	          			trailer.fillLevel = 0.0;
		    			trailer.currentFillType = FruitUtil.FRUITTYPE_UNKNOWN;
		    			self.activeUnloading = false;
	    			end;
	    			self:setFillLevel(self.fillLevel, trailer.currentFillType);
	    			trailer:setFillLevel(trailer.fillLevel-deltaLevel, trailer.currentFillType);
				end;
				end;
		end;
		
    end;
	
	
	
	--flashlights--
	
		if isDown and sym == Input.KEY_KP_1 then
		self.flashLeft = not self.flashLeft;
		self.delayOnLeft = 10;
		self.flashRight = false;
		self.flash = false;
		self.flashLightRightActive = false;
	end;

	if isDown and sym == Input.KEY_KP_3 then
		self.flashRight = not self.flashRight;
		self.delayOnRight = 10;
		self.flashLeft = false;
		self.flash = false;
		self.flashLightLeftActive = false;
	end;
	if isDown and sym == Input.KEY_KP_2 then
		self.flash = not self.flash;
		self.flashRight = false;
		self.flashLeft = false;
		self.delayOn = 20;
		self.flashLightRightActive = false;
		self.flashLightLeftActive = false;
	end;
	
end;
function Greatplains:update(dt)	

if self.attacherVehicle then
--buscar trailer y mostrar marker posicion 
	 self.currentFillType = self.seeds[self.currentSeed];
	self.trailerFound = 0;
	local x,y,z = getWorldTranslation(self.trailerPosition);
	raycastAll(x, y, z, 0, -1, 0, "findTrailerRaycastCallback", 10, self);
	if self.trailerFound == 0  and self.fillLevel==0 then
	setVisibility(self.trailer,true);
	end;
		-------------------
	-- eliminar marker posicion 
	if  self.Go.Lift or self.fillLevel >0 then
	setVisibility(self.trailer,false);
	end;
---abrir tapa
	-- if self.fillLevel ==0 and not self.Go.Lift then
	-- self.rotation3Max = true;
	-- end;
--cerrar tapa 	
	if self.fillLevel >= self.capacity then
	  self.fillLevel = self.capacity;
	self.rotation3Max = false;
	end;
	-------------------
	----ai-- -----
if self.attacherVehicle.isAITractorActivated then				
    	self.attacherVehicle.turnStage3Timeout = 0;
		self.stop = false;
		self.offsound =true;
			if self.fillLevel == 0 then
			AITractor.stopAITractor(self.attacherVehicle);
			self.stop = true;
				
			end;
			if self.attacherVehicle.turnStage == 0 then
			self.Go.Work = false; 
			self.Done.Work = true;
			-- self.activarAreas= true	;
			self.offsound =true;
			-- self.levelCheck =true;
			else
			self.Go.Work = true; 
			self.Done.Work = true;
			-- self.activarAreas= false;
			-- self.levelCheck =false;
			
			
			end;
	
else
		if self.fillLevel == self.capacity and self.stop then
			AITractor.startAITractor(self.attacherVehicle);
			self.stop = false;
			self.Go.Work = false; 
			self.Done.Work = true;
			-- self.activarAreas= true	;
			-- self.levelCheck =true;
		end;
		if self.attacherVehicle.isAITractorActivated ~= nil then
			self.attacherVehicle.turnStage3Timeout = 65000;
		end; 	
	end;

---------ai end----	

-- cerrar markers auto
if (self.CheckDone["Work"] == true) and self.Activated["Work"] == false   then
			self.Go.LeftMarker = false; 
			self.Done.LeftMarker = true;
			self.Go.RightMarker = false; 
			self.Done.RightMarker = true;
	end;
---------
		if self.Go.Lift ~= nil and self.Done.Lift ~= false then
			self:anim("Lift", false); 
		end;
		if self.Go.Work ~= nil and self.Done.Work ~= false then
			self:anim("Work", false); 
		end;
		if self.Go.LeftMarker ~= nil and self.Done.LeftMarker ~= false then
			self:anim("LeftMarker", false); 
		end;
		if self.Go.RightMarker ~= nil and self.Done.RightMarker ~= false then
			self:anim("RightMarker", false); 
		end;
  
--- flashLights
	if self.FlashLightLeft ~= nil then
            if self.flashLightLeftActive then
            	setVisibility(self.FlashLightLeft, self.flashLightLeftActive);
	    else
            	setVisibility(self.FlashLightLeft, self.flashLightLeftActive);
	    end;
        end;

	if self.FlashLightRight ~= nil then
            if self.FlashLightRightActive then
            	setVisibility(self.FlashLightRight, self.flashLightRightActive);
	    else
            	setVisibility(self.FlashLightRight, self.flashLightRightActive);
	    end;
        end;

	if self.flashLeft then
		if self.delayOnLeft >= -1 then
			self.delayOnLeft = self.delayOnLeft -dt;
		end;
		if not self.flashLightLeftActive then
			if self.delayOnLeft < 0 then
				self.delayOffLeft = 500;
				self.flashLightLeftActive = true;
				playSample(self.turnSoundId, 1, 0.7, 0);
			end;
		end;
		if self.delayOffLeft >= 0 then
			self.delayOffLeft = self.delayOffLeft -dt;
		end;
		if self.flashLightLeftActive then
			if self.delayOffLeft < 0 then
				self.delayOnLeft = 500;
				self.flashLightLeftActive = false;
			end;
		end;
	end;

	if self.flashRight then
		if self.delayOnRight >= 0 then
			self.delayOnRight = self.delayOnRight -dt;
		end;
		if not self.flashLightRightActive then
			if self.delayOnRight < 0 then
				self.delayOffRight = 500;
				self.flashLightRightActive = true;
				playSample(self.turnSoundId, 1, 0.7, 0);
			end;
		end;
		if self.delayOffRight >= 0 then
			self.delayOffRight = self.delayOffRight -dt;
		end;
		if self.flashLightRightActive then
			if self.delayOffRight < 0 then
				self.delayOnRight = 500;
				self.flashLightRightActive = false;
			end;
		end;
	end;

	if self.flash then
		if self.delayOn >= 0 then
			self.delayOn = self.delayOn -dt;
		end;
		if not self.flashLightRightActive then
			if self.delayOn < 0 then
				self.delayOff = 500;
				self.flashLightRightActive = true;
				self.flashLightLeftActive = true;
				playSample(self.turnSoundId, 1, 0.7, 0);
			end;
		end;
		if self.delayOff >= 0 then
			self.delayOff = self.delayOff -dt;
		end;
		if self.flashLightRightActive then
			if self.delayOff < 0 then
				self.delayOn = 500;
				self.flashLightLeftActive = false;
				self.flashLightRightActive = false;
			end;
		end;
	end;

	if not self.flashLeft and not self.flashRight then
		if not self.flash then
			self.flashLightRightActive = false;
			self.flashLightLeftActive = false;
		end;
	end;
		
	if not self.flash and not self.flashLeft then
		if not self.flashRight then
			self.flashLightRightActive = false;
		end;
	end;

	if not self.flash and not self.flashRight then
		if not self.flashLeft then
			self.flashLightLeftActive = false;
		end;
	end;
-----
if (self.CheckDone["Work"] == false) and self.Activated["Work"] == true and self.attacherVehicle.lastSpeed*3600 > 0.1  and not self.Go.Lift  and self.fillLevel > 0 and not self.Go.Work  then
----cultivator area and sound off in auto
if not self.offsound then
		if table.getn(self.cuttingAreas) > 0 then
				local x,y,z = getWorldTranslation(self.cuttingAreas[3].start);
				local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[3].width);
				local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[3].height);
				Utils.updateCultivatorArea(x, z, x1, z1, x2, z2);
			end;
	
	
		--- sound	 
		if self.attacherVehicle.lastSpeed*3600 > 2 then
			if not self.workSoundRunning then
                print("start");
                playSample(self.workSound, 0, 0.2, 0);
                self.workSoundRunning = true;
			end;
			end;
			if self.attacherVehicle.lastSpeed*3600 < 2 then
			if self.workSoundRunning then
                print("end");
                stopSample(self.workSound, 0, 0.2, 0);
                self.workSoundRunning = false;
			end;
			end;	
		end;
	---particulas
	 Utils.setEmittingState(self.groundParticleSystems1, self.lastSpeed*3600 > 5);
		 Utils.setEmittingState(self.groundParticleSystems2, self.lastSpeed*3600 > 5);
		 Utils.setEmittingState(self.groundParticleSystems3, self.lastSpeed*3600 > 5);
		  if not self.groundParticleSystemActive then
                	self.groundParticleSystemActive = true;
                	Utils.setEmittingState(self.groundParticleSystems1, true);
					Utils.setEmittingState(self.groundParticleSystems2, true);
					Utils.setEmittingState(self.groundParticleSystems3, true);
					
         end;
	----sowing area
				local x,y,z = getWorldTranslation(self.cuttingAreas[4].start);
                local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[4].width);
                local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[4].height);
				local area = 0;
			if self.fillLevel > 0 then
			area = Utils.updateSowingArea(self.currentFillType, x, z, x1, z1, x2, z2);
		else
			area = 0;
		end;
						
		
		if self.currentFillType ~= nil and self.currentFillType ~= FruitUtil.FRUITTYPE_UNKNOWN then 
            local fruitDesc = FruitUtil.fruitIndexToDesc[self.currentFillType];

            local pixelToQm = 2048 / 8192 * 2048 / 8192;
            local qm = area*pixelToQm;
            local ha = qm/10000;
		local speedFactor = self.attacherVehicle.lastSpeed*3600/12;
            local usage = fruitDesc.seedUsagePerQm*qm*speedFactor*5;
				if self.attacherVehicle.lastSpeed*3600 > 0.1 then 
			self:setFillLevel(self.fillLevel-usage, self.currentFillType);
		end;

            g_currentMission.missionStats.seedUsageTotal = g_currentMission.missionStats.seedUsageTotal + usage;
            g_currentMission.missionStats.seedUsageSession = g_currentMission.missionStats.seedUsageSession + usage;

            g_currentMission.missionStats.hectaresSeededTotal = g_currentMission.missionStats.hectaresSeededTotal + ha;
            g_currentMission.missionStats.hectaresSeededSession = g_currentMission.missionStats.hectaresSeededSession + ha;

            g_currentMission.missionStats.seedingDurationTotal = g_currentMission.missionStats.seedingDurationTotal + dt/(1000*60);
            g_currentMission.missionStats.seedingDurationSession = g_currentMission.missionStats.seedingDurationSession + dt/(1000*60);
	----limitaciones de velocidad
          	if self:doCheckSpeedLimit() and self.lastSpeed*3600 > 10 then
            	self.speedViolationTimer = self.speedViolationTimer - dt;
                	if self.speedViolationTimer < 0 then
                    	if self.attacherVehicle ~= nil then
						--- si esta enganchado desconectarlo por esceso de velocidad
                       		self.attacherVehicle:detachImplementByObject(self);
                    	end;
                	end;
            else
                	self.speedViolationTimer = self.speedViolationMaxTime;
           	end;
	end;
----en caso contrario
else
		  	Utils.setEmittingState(self.groundParticleSystems1, false);
			Utils.setEmittingState(self.groundParticleSystems2, false);
			Utils.setEmittingState(self.groundParticleSystems3, false);
			
            self.speedViolationTimer = self.speedViolationMaxTime; --maxima velociad fuera de areas
			if self.workSoundRunning then
                print("end");
                stopSample(self.workSound, 0, 0.2, 0);
                self.workSoundRunning = false;
			end;
				 
	end; ---final work	 
-----
if (self.CheckDone["LeftMarker"] == true) and self.Activated["LeftMarker"] == false and self.go and self.attacherVehicle.lastSpeed*3600 > 0.1 then
		if self.drumNode1 ~= nil then
		rotate(self.drumNode1,(self.drumRotationScale *1),0 , 0);
		end;
			if table.getn(self.cuttingAreas) > 0 then
				local x,y,z = getWorldTranslation(self.cuttingAreas[1].start);
				local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[1].width);
				local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[1].height);
				Utils.updatePloughArea(x, z, x1, z1, x2, z2);
			end;
	end;
	if (self.CheckDone["RightMarker"] == true) and self.Activated["RightMarker"] == false and self.go and self.attacherVehicle.lastSpeed*3600 > 0.1 then
		if self.drumNode2 ~= nil then
		rotate(self.drumNode2,(self.drumRotationScale *1),0, 0);
		end;
			if table.getn(self.cuttingAreas) > 0 then
				local x,y,z = getWorldTranslation(self.cuttingAreas[2].start);
				local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[2].width);
				local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[2].height);
				Utils.updatePloughArea(x, z, x1, z1, x2, z2);
			end;
	end;		

end; ---final condiciones  con attacher vehicle

--- rotaciones y translaciones


		
	if self.rotation1Max ~= nil then
        local x, y, z = getRotation(self.rotation1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation1.maxRot, self.rotation1.minRot, 3, self.rotation1.rotTime, dt, not self.rotation1Max);
        setRotation(self.rotation1.node, unpack(newRot));
    end;
	
	
	if self.rotation2Max ~= nil then
        local x, y, z = getRotation(self.rotation2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation2.maxRot, self.rotation2.minRot, 3, self.rotation2.rotTime, dt, not self.rotation2Max);
        setRotation(self.rotation2.node, unpack(newRot));
    end;
	if self.rotation3Max ~= nil then
        local x, y, z = getRotation(self.rotation3.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation3.maxRot, self.rotation3.minRot, 3, self.rotation3.rotTime, dt, not self.rotation3Max);
        setRotation(self.rotation3.node, unpack(newRot));
    end;
	if self.rotation4Max ~= nil then
        local x, y, z = getRotation(self.rotation4.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation4.maxRot, self.rotation4.minRot, 3, self.rotation4.rotTime, dt, not self.rotation4Max);
        setRotation(self.rotation4.node, unpack(newRot));
    end;
	if self.rotation5Max ~= nil then
        local x, y, z = getRotation(self.rotation5.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation5.maxRot, self.rotation5.minRot, 3, self.rotation5.rotTime, dt, not self.rotation5Max);
        setRotation(self.rotation5.node, unpack(newRot));
    end;
-- juntas
--- asignacion de ejes de libertad  de rotacion segun condiciones de emsamblage  0 x, 2 y ,1 z 
---cuando se ejecuta lift le quita la libertad bloques 12 13 22 23
--- cuando se abren los markers le permite libertad bloque 18 19 20 21

	self:setJointRotLimit(self.componentJoints[12],0, 2, 1000,  self.Go.Lift, 2,dt);
	self:setJointRotLimit(self.componentJoints[13],0, 2, 1000,  self.Go.Lift, 2,dt);
	self:setJointRotLimit(self.componentJoints[22],0, 2, 1000, self.Go.Lift, 2,dt);
	self:setJointRotLimit(self.componentJoints[23],0, 2, 1000,  self.Go.Lift, 2,dt);
	self:setJointRotLimit(self.componentJoints[18],0, 3, 1000, not self.Go.LeftMarker, 1,dt);
	self:setJointRotLimit(self.componentJoints[19],0, 3, 1000, not self.Go.RightMarker, 1,dt);
	self:setJointRotLimit(self.componentJoints[20],0, 5, 1000,not self.Go.LeftMarker, 1,dt);
	self:setJointRotLimit(self.componentJoints[21],0, 5, 1000, not self.Go.RightMarker, 1,dt);
	self:setJointRotLimit(self.componentJoints[2],12, 2, 1000, not self.Go.Work, 0,dt);
	self:setJointRotLimit(self.componentJoints[2],2, 2, 1000, true, 2,dt);
	
	
	
	
	
		local joint = self.componentJoints[1];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[2];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[3];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[4];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[5];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[6];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[7];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[8];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[9];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[10];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[11];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[12];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[13];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[14];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[15];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[16];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[17];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[18];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[19];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[20];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[21];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[22];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[23];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		---- trasera sembradoras
		local joint = self.componentJoints[24];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[25];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[26];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[27];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[28];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[29];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[30];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[31];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[32];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[33];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[34];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[35];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[36];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[37];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[38];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[39];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[40];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[41];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[42];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[43];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[44];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[45];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[46];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[47];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[48];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[49];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[50];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[51];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[52];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[53];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[54];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[55];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
		
		
		---llamada a especializacion
			self:setHydraulicDirection();
	
end;
function  Greatplains:draw()
if self.currentFillType ~= nil and self.currentFillType ~= FruitUtil.FRUITTYPE_UNKNOWN then
	 	g_currentMission.fruitOverlays[self.currentFillType]:render();---imagen semilla
	end;
if (not self.attacherVehicle.isAITractorActivated) then	
	-- if self.attacherVehicle and self.autorizacion then
	-- g_currentMission:addExtraPrintText(" AUTHORITATION ");
	-- else
	-- g_currentMission:addExtraPrintText(" apertura y cierre no autorizado");
	-- end;
	if self.fillLevel == 0 then	
			-- g_currentMission:addExtraPrintText(" x Drain seed boxes on ground");
	-- else
		g_currentMission:addExtraPrintText("move planter to trailer to fill and press O");
		end;
	if   self.Go.Work  and not self.go then
		g_currentMission:addExtraPrintText("n close sowing machine");
	-- else
	-- g_currentMission:addExtraPrintText("n open sowing machine");
	end;
	if (self.CheckDone["Lift"] == false) and self.Activated["Lift"] == true and not self.go then
	g_currentMission:addExtraPrintText("x markers position");
	end;
	if (self.CheckDone["Lift"] == true) and self.Activated["Lift"] == false then
	g_currentMission:addExtraPrintText("n open sowing machine");
	end;
	if self.go and not self.Go.Work then
	g_currentMission:addExtraPrintText(" v raise planter, Kp7 marker left ,Kp8 close markers, Kp9, marker right");
	end;
	if self.go and  self.Go.Work then
	g_currentMission:addExtraPrintText(" v lower, Kp7 marker left ,Kp8 close markers, Kp9, marker right");
	end;
 if math.abs(self.speedViolationTimer - self.speedViolationMaxTime) > 2 then
        	g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_fast") .. "\n" .. string.format(g_i18n:getText("Cruise_control_levelN"), "1", InputBinding.getButtonKeyName(InputBinding.SPEED_LEVEL1)), 0.07+0.022, 0.019+0.029);
    	end;
else
g_currentMission:addExtraPrintText(" Auto");
end;
end;
function Greatplains:setHydraulicDirection()
	for i=1, table.getn(self.hydraulics) do
		local ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
		local bx, by, bz = getWorldTranslation(self.hydraulics[i].fixPoint);
		local x, y, z = worldDirectionToLocal(getParent(self.hydraulics[i].node), bx-ax, by-ay, bz-az);
		
		setDirection(self.hydraulics[i].node, x, y, z, 0, 1, 0);
		local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		if self.hydraulics[i].doScale then
			local xScale, yScale, zScale = getScale(self.hydraulics[i].node);
			local newScale = yScale * (distance / self.hydraulics[i].punchDistance);
			setScale(self.hydraulics[i].node, 1, 1, newScale);
		else
			if self.hydraulics[i].punch ~= nil then
				setTranslation(self.hydraulics[i].punch, 0, 0, distance-self.hydraulics[i].punchDistance);
			end;
		end;
	
	end;
end;
function Greatplains:onAttach()	
	
	self.rotation1Max = true;
	self.Go.Work = true;
	self.Done.Work = true;		

	
end;		
function Greatplains:onDetach()
	self.rotation1Max = false;

end;
function Greatplains:anim(varName, loopCheck)	
	-- print("ANIMATION");
	
	self.Activated[varName] = true;

	if self.Go[varName] == true and self.Done[varName] ~= false then
		local charId = getAnimCharacterSet(self.charId[varName]);
		local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
		assignAnimTrackClip(charId , 0, clipIndex);
		setAnimTrackLoopState(charId, 0, loopCheck);
		setAnimTrackSpeedScale(charId, 0, 1);
		enableAnimTrack(charId, 0);
		if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck == false then
			disableAnimTrack(charId, 0);	
			self.Done[varName] = false;	
			self.CheckDone[varName] = true;	
			self.Activated[varName] = false;
		
			---final animacion hacia delante
		end; 
	elseif self.Go[varName] == false and self.Done[varName] ~= false then
		local charId = getAnimCharacterSet(self.charId[varName]);
		local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
		if loopCheck == true then
			disableAnimTrack(charId, 0);
			self.Done[varName] = false;	
		end; 	
		assignAnimTrackClip(charId , 0, clipIndex);
		setAnimTrackLoopState(charId, 0, loopCheck);
		setAnimTrackSpeedScale(charId, 0, -1);
		enableAnimTrack(charId, 0);
		if getAnimTrackTime(charId, 0) <= 0 then
			disableAnimTrack(charId, 0);
			self.Done[varName] = false;	
			self.CheckDone[varName] = false;
			self.Activated[varName] = true;
			---final animacion hacia atras
		
		end;
	end;
end; 


function Greatplains:AllActivated()
	
	if (self.CheckDone["Lift"] == true) and not self.Activated["Lift"]  then
		return true;
	else
		return false;
	end;
	
	if (self.CheckDone["Work"] == true) and not self.Activated["Work"]  then
		return true;
	else
		return false;
	end;
	if (self.CheckDone["LeftMarker"] == true) and not self.Activated["LeftMarker"]  then
		return true;
	else
		return false;
	end;
	if (self.CheckDone["RightMarker"] == true) and not self.Activated["RightMarker"]  then
		return true;
	else
		return false;
	end;

	
	
end;
function Greatplains:setFillLevel(fillLevel, fillType)

    self.fillLevel = fillLevel;
    if self.fillLevel > self.capacity then
        self.fillLevel = self.capacity;
    end;
    if self.fillLevel < 0 then
        self.fillLevel = 0;
    end;
    if self.currentGrainPlane ~= nil then
        setVisibility(self.currentGrainPlane, false);
    end;
    if self.grainPlanes ~= nil and self.defaultGrainPlane ~= nil then
        local fillTypeName = FruitUtil.fruitIndexToDesc[self.seeds[self.currentSeed]].name;
        local grainPlane = self.grainPlanes[fillTypeName];
        if grainPlane == nil then
            grainPlane = self.defaultGrainPlane;
        end;
        local yTranslation;
        if self.grainAnimCurve then
            local scaleX, scaleY, scaleZ , yTrans = self.grainAnimCurve:get(self.fillLevel/self.capacity);
            yTranslation = yTrans;
            setScale(grainPlane, scaleX, scaleY, scaleZ);
        else
            local m = (self.grainPlaneMaxY - self.grainPlaneMinY) / self.capacity;
            yTranslation = m*self.fillLevel + self.grainPlaneMinY;
        end;
        local xPos, yPos, zPos = getTranslation(grainPlane);
        setTranslation(grainPlane, xPos, yTranslation, zPos);
        setVisibility(grainPlane, self.fillLevel > 0);
        self.currentGrainPlane = grainPlane;
    end;
end;
			
function Greatplains:setJointRotLimit(nodei, up, down, speed, value, axle, dt)

	if not self.firstDo[nodei] then
		self.firstDo[nodei] = true;
		self.arm[nodei] = {0}; 
	end; 
	x, y, z = getRotation(nodei);
	rot = {x,y,z};	
	newRotLimit = {}; 
	newRotLimit[nodei] = {0,0,0};
	newRotLimit[nodei] = Utils.getMovedLimitedValues(self.arm[nodei], {down}, {up}, 1, speed * 2, dt, value);
	if math.abs(newRotLimit[nodei][1] - self.arm[nodei][1]) > 0.001 then
		local joint = nodei;
		setJointRotationLimit(joint.jointIndex, axle, true, Utils.degToRad(-newRotLimit[nodei][1]), Utils.degToRad(newRotLimit[nodei][1]));
	end;
	self.arm[nodei] = newRotLimit[nodei];			
end;

